%define our_platform i586_linux_2.0_glibc2.1
%define our_platform2 gcc2.96

Name: libomniORB
Version: 3.0.5
Release: alt1

Summary: ORB from AT&T
Copyright: GPL
Group: Development/C++
URL: http://omniorb.sourceforge.net/

Source: omniORB_305.tar.bz2

Source1: omniEvents_2.1.1.tar.bz2
Source2: omniNotify12.tar.bz2
Source3: omniORBpy_1_5.tar.bz2

Source100: omniORB.cfg
Source101: channel.cfg

Patch: omni-3.0.5-alt-events-gcc3.patch

# Automatically added by buildreq on Wed Sep 04 2002
BuildRequires: XFree86-utils gcc-c++ libomniORB-devel libstdc++-devel python-devel tkinter

%description
omniORB is an Object Request Broker (ORB) that implements the 2.3            
specification of the Common Object Request Broker Architecture               
(CORBA) [OMG99]. It has passed the Open Group CORBA compliant         
testsuite and is one of the three ORBs to have been granted the CORBA        
brand in June 1999.                                                      
This user guide tells you how to use omniORB to develop CORBA                
applications. It assumes a basic understanding of CORBA.                     
In this chapter, we give an overview of the main features of omniORB         
and what you need to do to setup your environment to run omniORB. 

%package devel
Summary: development part of omniORB
Group: Development/C++
Requires: %name = %version-%release, python = %__python_version 

%description devel
This devel package includes the libraries and header files
for the omniORB package.

%package devel-static
Summary: development part of omniORB
Group: Development/C++
Requires: %name-devel = %version-%release

%description devel-static
This devel package includes static libraries
for the omniORB package.

%package demos
Summary: demo stuff for omniORB
Group: Development/C++
Requires: %name = %version-%release

%description demos
demo stuff for omniORB

%prep
%setup -q -n omni -a1 -a2 -a3
%patch -p1

perl -pi -e 's@^#platform[[:space:]]=[[:space:]]%{our_platform}@platform = %{our_platform}_%{our_platform2}@'  config/config.mk
perl -pi -e 's@external_merge@@'  mk/platforms/%{our_platform}_%{our_platform2}.mk

#temporary removed . omniNotify doesn't build.
#perl -pi -e 's@D__linux__@D__linux__ \$\(RPM_OPT_FLAGS\)@'  mk/platforms/%{our_platform}.mk

perl -pi -e 's@OMNINAMES_LOG_DEFAULT_LOCATION.*@OMNINAMES_LOG_DEFAULT_LOCATION = /var/lib/omniORB/@'  mk/platforms/%{our_platform}.mk
perl -pi -e 's@OMNIORB_CONFIG_DEFAULT_LOCATION.*@OMNIORB_CONFIG_DEFAULT_LOCATION = /etc/omniORB/omniORB.cfg@'  mk/platforms/%{our_platform}.mk
perl -pi -e 's@OMNIORB_CONFIG_DEFAULT_LOCATION.*@OMNIORB_CONFIG_DEFAULT_LOCATION = /etc/omniORB/omniORB.cfg@'  mk/platforms/%{our_platform}_%{our_platform2}.mk

perl -pi -e 's@#\s.*OMNIEVENTS_LOG_DEFAULT_LOCATION.*@OMNIEVENTS_LOG_DEFAULT_LOCATION = /var/lib/omniORB/@'  src/contrib/omniEvents/config/config.mk

%build
cd src
%make_build TOP=%_builddir/omni/ export
%make_build -C contrib/omniEvents export
%make_build -C services/omniNotify export
%make_build -C lib/omniORBpy export

%install
#hand-made install
mkdir -p $RPM_BUILD_ROOT%_bindir
for i in `find bin/%{our_platform}_%{our_platform2} -type f`;do
 cp $i $RPM_BUILD_ROOT%_bindir
done

for i in `find bin/scripts -type f -name 'o*'`;do
 cp $i $RPM_BUILD_ROOT%_bindir
done

for i in `find $RPM_BUILD_ROOT%_bindir -type f -name 'o*'`;do
    perl -pi -e s@/usr/local/bin@/bin@g  $i
done

mv $RPM_BUILD_ROOT%_bindir/ols  $RPM_BUILD_ROOT%_bindir/o_ls 

mkdir -p $RPM_BUILD_ROOT%_docdir/%name-%version
(cd doc;cp -a * $RPM_BUILD_ROOT%_docdir/%name-%version)

mkdir -p $RPM_BUILD_ROOT%_includedir
(cd include;cp -a * $RPM_BUILD_ROOT%_includedir)

mkdir -p $RPM_BUILD_ROOT%_libdir
mkdir -p $RPM_BUILD_ROOT%_libdir/python%__python_version/site-packages/
(cd lib/%{our_platform}_%{our_platform2};
find . -name '_*.so' -exec cp '{}'  $RPM_BUILD_ROOT%_libdir/python%__python_version/site-packages/ ';'
find . -name 'o*' -exec cp -d '{}'  $RPM_BUILD_ROOT%_libdir/python%__python_version/site-packages/ ';'
chmod a+x -R $RPM_BUILD_ROOT%_libdir/python%__python_version/site-packages/
find . -name 'l*' -exec cp -d '{}'  $RPM_BUILD_ROOT%_libdir/ ';'

)

mkdir -p $RPM_BUILD_ROOT%_libdir/python%__python_version/
(cd lib/python;cp -a * $RPM_BUILD_ROOT%_libdir/python%__python_version)

#mv $RPM_BUILD_ROOT%_libdir/omnicpp $RPM_BUILD_ROOT%_bindir

mkdir -p $RPM_BUILD_ROOT%_mandir/man1
for i in `find man/man1 -type f`;do
 cp $i $RPM_BUILD_ROOT%_mandir/man1
done

(cd src/contrib/omniEvents
    (cd bin/%{our_platform}_%{our_platform2}; cp -a * $RPM_BUILD_ROOT%_bindir)
    (cd lib/%{our_platform}_%{our_platform2}
	for i in `ls *.so.*.*`;do
	cp $i $RPM_BUILD_ROOT%_libdir;
	ln -s %_libdir/$i $RPM_BUILD_ROOT%_libdir/`basename $i .0`
	ln -s `basename $i .0` $RPM_BUILD_ROOT%_libdir/`basename $i .1.0`
	done
    )
)

#prepare filelists
/bin/ls -1 $RPM_BUILD_ROOT%_bindir |
        egrep -v '(ior|nameclt|omniMapper|omniNames|omniEvents|notifd|*push*|*pull*|*demo*)' |
	        sed -e 's|^\(.*\)$|%%_bindir/\1|g' >%name.devel

(cd $RPM_BUILD_ROOT%_libdir/python%__python_version
  find -type f|
  sed -e 's@\.\/@%_libdir/python%__python_version/@'|
  sed -e 's@\.py.*@.py*@'|
  sort -u >> %_builddir/omni/%name.devel
  find -type d -mindepth 1|
  sed -e 's@\.\/@%%dir %_libdir/python%__python_version/@'|
  grep -v '%_libdir/python%__python_version/site-packages$' >> %_builddir/omni/%name.devel
)

mkdir -p $RPM_BUILD_ROOT%_sysconfdir/omniORB/
install -p -m644 %SOURCE100 $RPM_BUILD_ROOT%_sysconfdir/omniORB/omniORB.cfg
install -p -m644 %SOURCE101 $RPM_BUILD_ROOT%_sysconfdir/omniORB/omniNotify.cfg
mkdir -p -m755 $RPM_BUILD_ROOT/var/lib/omniORB/

%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%files
%config(noreplace) %_sysconfdir/omniORB/*
%attr(755,daemon,daemon) %dir /var/lib/omniORB
%_bindir/*ior*
%_bindir/nameclt
%_bindir/omniNames
%_bindir/omniMapper
%_bindir/omniEvents
%_bindir/notifd
%_mandir/man?/*
%_libdir/*.so.*
%doc %_docdir/%name-%version

%files devel -f %name.devel
%_includedir/*
%_libdir/*.so


%files devel-static
%_libdir/*.a

%files demos
%_bindir/*push*
%_bindir/*pull*
%_bindir/*demo*

%changelog
* Wed Sep 04 2002 Stanislav Ievlev <inger@altlinux.ru> 3.0.5-alt1
- 3.0.5
- build with gcc3

* Tue Feb 12 2002 Stanislav Ievlev <inger@altlinux.ru> 3.0.4-alt11
- fix dirs ownerships.

* Tue Jan 29 2002 Stanislav Ievlev <inger@altlinux.ru> 3.0.4-alt10
- added latest bugfix patches to omniORBpy and omniNotify
- rebuild with new python

* Fri Oct 19 2001 Stanislav Ievlev <inger@altlinux.ru> 3.0.4-alt9
- omniNotify 1.1
- latest bugfixes for omniORB and omniORBpy

* Mon Sep 10 2001 Stanislav Ievlev <inger@altlinux.ru> 3.0.4-alt8
- Applied latest bugfixes.

* Mon Jul 30 2001 Stanislav Ievlev <inger@altlinux.ru> 3.0.4-alt7
- Added omniROBpy package.
- move python files to right place.

* Thu Jul 26 2001 Stanislav Ievlev <inger@altlinux.ru> 3.0.4-alt6
- Added omniNotify service
- New package with demo stuff.

* Tue Jul 24 2001 Stanislav Ievlev <inger@altlinux.ru> 3.0.4-alt5
- Added omniEvents service.

* Fri Jul 06 2001 Stanislav Ievlev <inger@altlinux.ru> 3.0.4-alt4
- Small fixes. Buildreq and Requires on python.

* Tue Jul 03 2001 Stanislav Ievlev <inger@altlinux.ru> 3.0.4-alt3
- Changed default config and log locations.

* Mon Jul 02 2001 Stanislav Ievlev <inger@altlinux.ru> 3.0.4-alt2
- Splited bin files into main package and devel. Added config file.

* Fri Jun 29 2001 Stanislav Ievlev <inger@altlinux.ru> 3.0.4-alt1
- 3.0.4

* Wed Jun 27 2001 Stanislav Ievlev <inger@altlinux.ru> 3.0.3-alt3
- Rebuilt with python-2.1

* Wed May 16 2001 Stanislav Ievlev <inger@altlinux.ru> 3.0.3-alt2
- Rename ols to o_ls to avoid conflicts with speach_*

* Wed Apr 25 2001 Stanislav Ievlev <inger@altlinux.ru> 3.0.3-alt1
- Initial release for ALT Linux
